# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Defined types

* [`windows_eventlog`](#windows_eventlog): Manage Windows Event Logs

## Defined types

### <a name="windows_eventlog"></a>`windows_eventlog`

Manage windows event logs including the size, rotation and retention

#### Examples

##### Manage the size of the Application log:

```puppet
windows_eventlog { 'Application':
  log_path       => '%SystemRoot%\system32\winevt\Logs\Application.evtx',
  log_size       => '2048',
  max_log_policy => 'overwrite'
}
```

##### Manage several custom event logs under C:\Logs:

```puppet
windows_eventlog { ['Custom1', 'Custom2', 'Custom3']:
  log_path_template => 'C:\Logs\%%NAME%%.evtx'
}
```

#### Parameters

The following parameters are available in the `windows_eventlog` defined type:

* [`log_path`](#-windows_eventlog--log_path)
* [`log_size`](#-windows_eventlog--log_size)
* [`max_log_policy`](#-windows_eventlog--max_log_policy)
* [`log_path_template`](#-windows_eventlog--log_path_template)
* [`root_key`](#-windows_eventlog--root_key)

##### <a name="-windows_eventlog--log_path"></a>`log_path`

Data type: `Optional[String[1]]`

The path to the log file that you want to manage

Default value: `undef`

##### <a name="-windows_eventlog--log_size"></a>`log_size`

Data type: `Integer`

The max size of the log file

Default value: `1028`

##### <a name="-windows_eventlog--max_log_policy"></a>`max_log_policy`

Data type: `Enum['overwrite', 'manual', 'archive']`

The retention policy for the log

Default value: `'overwrite'`

##### <a name="-windows_eventlog--log_path_template"></a>`log_path_template`

Data type: `String[1]`

A template for log_path, where "%%NAME%%" will be replaced with the log name

Default value: `'%SystemRoot%\system32\winevt\Logs\%%NAME%%.evtx'`

##### <a name="-windows_eventlog--root_key"></a>`root_key`

Data type: `String[1]`

The root path of the registry key of which prepends this defined type

Default value: `'HKLM\System\CurrentControlSet\Services\Eventlog'`

